// MyButton.h : Declaration of the CMyButton

#pragma once
#include "resource.h"       // main symbols

#include <shlguid.h>        // IID_IWebBrowser2, DIID_DWebBrowserEvents2, etc.
#include <exdispid.h>       // DISPID_DOCUMENTCOMPLETE, etc.
#include <mshtml.h>         // DOM interfaces

#include <vcclr.h> 

#include "MyIeAddon_i.h"

#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif

using namespace ATL;



// CMyButton

class ATL_NO_VTABLE CMyButton :
    public CComObjectRootEx<CComSingleThreadModel>,
    public CComCoClass<CMyButton, &CLSID_MyButton>,
    public IObjectWithSiteImpl<CMyButton>,
    public IDispatchImpl<IMyButton, &IID_IMyButton, &LIBID_MyIeAddonLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
    public IDispEventImpl<1, CMyButton, &DIID_DWebBrowserEvents2, &LIBID_SHDocVw, 1, 1>,
    public IDispEventImpl<0, CMyButton, &DIID_HTMLDocumentEvents2, &LIBID_MSHTML, 4, 0>,
    public IOleCommandTarget

{
public:
    CMyButton()
    {
    }

DECLARE_REGISTRY_RESOURCEID(IDR_MYBUTTON)

DECLARE_NOT_AGGREGATABLE(CMyButton)

BEGIN_SINK_MAP(CMyButton)
    SINK_ENTRY_EX(1, DIID_DWebBrowserEvents2, DISPID_DOCUMENTCOMPLETE, OnDocumentComplete)
END_SINK_MAP()


BEGIN_COM_MAP(CMyButton)
    COM_INTERFACE_ENTRY(IMyButton)
    COM_INTERFACE_ENTRY(IDispatch)
    COM_INTERFACE_ENTRY(IObjectWithSite)
    COM_INTERFACE_ENTRY(IOleCommandTarget)
END_COM_MAP()



    DECLARE_PROTECT_FINAL_CONSTRUCT()

    HRESULT FinalConstruct()
    {
        return S_OK;
    }

    void FinalRelease()
    {
    }

public:

    // IObjectWithSite
    STDMETHOD(SetSite)(IUnknown *pUnkSite);

    // IOleCommandTarget
    STDMETHOD(Exec)(const GUID *pguidCmdGroup, DWORD nCmdID, DWORD nCmdExecOpt, VARIANTARG *pvaIn, VARIANTARG *pvaOut);
    STDMETHOD(QueryStatus)(const GUID *pguidCmdGroup, ULONG cCmds, OLECMD *prgCmds, OLECMDTEXT *pCmdText);

    // DWebBrowserEvents2
    void STDMETHODCALLTYPE OnDocumentComplete(IDispatch *pDisp, VARIANT *pvarURL); 

private:

    CComPtr<IWebBrowser2>  m_spWebBrowser;
    BOOL m_fAdvised; 
    CComQIPtr<IOleCommandTarget,  &IID_IOleCommandTarget> m_spTarget;


};

OBJECT_ENTRY_AUTO(__uuidof(MyButton), CMyButton)
